@import "variables";
@import "utility";
@import "wysiwyg";
@import "~bootstrap/scss/utilities/text";
@import "~bootstrap/scss/utilities/screenreaders";

$typo-sizes: (
  root: (
    fs: $base-fontsize,
    lh: 28px
  ),
  p: (
    fs: inherit,
    lh: inherit,
    lhm: inherit
  ),
  a-10: (
    mobile: (
      fs: 13px,
      lh: 17px,
      lhm: 1.3
    ),
    tablet: (
      fs: 13px,
      lh: 17px,
      lhm: 1.3
    ),
    desktop: (
      fs: 13px,
      lh: 17px,
      lhm: 1.3
    ),
    lgdesktop: (
      fs: 13px,
      lh: 17px,
      lhm: 1.3
    )
  ),
  a-9: (
    mobile: (
      fs: 16px,
      lh: 21px,
      lhm: 1.3
    ),
    tablet: (
      fs: 16px,
      lh: 21px,
      lhm: 1.3
    ),
    desktop: (
      fs: 16px,
      lh: 21px,
      lhm: 1.3
    ),
    lgdesktop: (
      fs: 16px,
      lh: 21px,
      lhm: 1.3
    )
  ),
  a-8: (
    mobile: (
      fs: 16px,
      lh: 21px,
      lhm: 1.3
    ),
    tablet: (
      fs: 16px,
      lh: 21px,
      lhm: 1.3
    ),
    desktop: (
      fs: 18px,
      lh: 23px,
      lhm: 1.3
    ),
    lgdesktop: (
      fs: 18px,
      lh: 23px,
      lhm: 1.3
    )
  ),
  a-7: (
    mobile: (
      fs: 16px,
      lh: 21px,
      lhm: 1.3
    ),
    tablet: (
      fs: 18px,
      lh: 23px,
      lhm: 1.3
    ),
    desktop: (
      fs: 20px,
      lh: 26px,
      lhm: 1.3
    ),
    lgdesktop: (
      fs: 20px,
      lh: 26px,
      lhm: 1.3
    )
  ),
  a-6: (
    mobile: (
      fs: 16px,
      lh: 21px,
      lhm: 1.3
    ),
    tablet: (
      fs: 18px,
      lh: 23px,
      lhm: 1.3
    ),
    desktop: (
      fs: 24px,
      lh: 31px,
      lhm: 1.3
    ),
    lgdesktop: (
      fs: 24px,
      lh: 31px,
      lhm: 1.3
    )
  ),
  a-5: (
    mobile: (
      fs: 20px,
      lh: 26px,
      lhm: 1.3
    ),
    tablet: (
      fs: 24px,
      lh: 31px,
      lhm: 1.3
    ),
    desktop: (
      fs: 32px,
      lh: 35px,
      lhm: 1.1
    ),
    lgdesktop: (
      fs: 32px,
      lh: 35px,
      lhm: 1.1
    )
  ),
  a-4: (
    mobile: (
      fs: 24px,
      lh: 31px,
      lhm: 1.3
    ),
    tablet: (
      fs: 32px,
      lh: 35px,
      lhm: 1.1
    ),
    desktop: (
      fs: 40px,
      lh: 44px,
      lhm: 1.1
    ),
    lgdesktop: (
      fs: 40px,
      lh: 44px,
      lhm: 1.1
    )
  ),
  a-3: (
    mobile: (
      fs: 32px,
      lh: 35px,
      lhm: 1.1
    ),
    tablet: (
      fs: 40px,
      lh: 44px,
      lhm: 1.1
    ),
    desktop: (
      fs: 48px,
      lh: 53px,
      lhm: 1.1
    ),
    lgdesktop: (
      fs: 48px,
      lh: 53px,
      lhm: 1.1
    )
  ),
  a-2: (
    mobile: (
      fs: 32px,
      lh: 35px,
      lhm: 1.1
    ),
    tablet: (
      fs: 48px,
      lh: 53px,
      lhm: 1.1
    ),
    desktop: (
      fs: 56px,
      lh: 62px,
      lhm: 1.1
    ),
    lgdesktop: (
      fs: 56px,
      lh: 62px,
      lhm: 1.1
    )
  ),
  a-1: (
    mobile: (
      fs: 64px,
      lh: 70px,
      lhm: 1.1
    ),
    tablet: (
      fs: 80px,
      lh: 88px,
      lhm: 1.1
    ),
    desktop: (
      fs: 116px,
      lh: 128px,
      lhm: 1.1
    ),
    lgdesktop: (
      fs: 144px,
      lh: 158px,
      lhm: 1.1
    )
  ),
  w-5: (
    mobile: (
      fs: 24px,
      lh: 26px,
      lhm: 1.1
    ),
    tablet: (
      fs: 32px,
      lh: 35px,
      lhm: 1.1
    ),
    desktop: (
      fs: 32px,
      lh: 35px,
      lhm: 1.1
    ),
    lgdesktop: (
      fs: 32px,
      lh: 37px,
      lhm: 1.16
    )
  ),
  w-4: (
    mobile: (
      fs: 24px,
      lh: 26px,
      lhm: 1.1
    ),
    tablet: (
      fs: 32px,
      lh: 35px,
      lhm: 1.1
    ),
    desktop: (
      fs: 40px,
      lh: 44px,
      lhm: 1.1
    ),
    lgdesktop: (
      fs: 48px,
      lh: 53px,
      lhm: 1.1
    )
  ),
  w-3: (
    mobile: (
      fs: 32px,
      lh: 35px,
      lhm: 1.1
    ),
    tablet: (
      fs: 40px,
      lh: 44px,
      lhm: 1.1
    ),
    desktop: (
      fs: 56px,
      lh: 62px,
      lhm: 1.1
    ),
    lgdesktop: (
      fs: 64px,
      lh: 70px,
      lhm: 1.1
    )
  ),
  w-2: (
    mobile: (
      fs: 40px,
      lh: 44px,
      lhm: 1.1
    ),
    tablet: (
      fs: 56px,
      lh: 62px,
      lhm: 1.1
    ),
    desktop: (
      fs: 72px,
      lh: 79px,
      lhm: 1.1
    ),
    lgdesktop: (
      fs: 96px,
      lh: 106px,
      lhm: 1.1
    )
  ),
  w-1: (
    mobile: (
      fs: 56px,
      lh: 62px,
      lhm: 1.1
    ),
    tablet: (
      fs: 80px,
      lh: 88px,
      lhm: 1.1
    ),
    desktop: (
      fs: 116px,
      lh: 128px,
      lhm: 1.1
    ),
    lgdesktop: (
      fs: 144px,
      lh: 158px,
      lhm: 1.1
    )
  )
);

@mixin typo-font($font-family, $font-size: 16px, $font-weight: 400, $font-style: normal) {
  font-family: $font-family, $font-system;
  font-size: $font-size;
  font-weight: $font-weight;
  font-style: $font-style;
}

// @mixin typo-font-families() {
//   @each $key, $value in $fonts {
//     .typo-#{$key} {
//       font-family: '#{$value}';

//       @if $key == 'a' {
//         letter-spacing: 0;
//       } @else {
//         letter-spacing: 2px;
//       }

//     }
//     @each $name, $weight in $weights {
//       .typo-#{$key}-#{$name} {
//         font-family: '#{$value}';
//         font-weight: #{$weight};
//         @if $key == 'a' {
//           letter-spacing: 0;
//         } @else {
//           letter-spacing: 2px;
//         }
//       }
//     }
//   }
// }

@function _get_fs-height($fs, $lh) {
  @return ($lh / $fs);
}

@mixin _set-fs($val) {
  $fs: fetch($val, "fs");
  //$lh: fetch($val, "lh"); //with pixel
  $lh: fetch($val, "lhm"); //with proportional
  @if $fs and $fs != inherit {
    font-size: $fs;
  }
  @if $lh {
    @if $fs != inherit {
      //line-height: _get_fs-height($fs, $lh); //with pixel
      line-height: $lh; //with proportional
    }
  }
}

@mixin typo-steps($values) {
  @if (type-of($values) == 'map') {
    @each $step, $val in $values {
      @if $step == lgdesktop {
        @include query-above(fetch($q, lgdesktop)) {
          @include _set-fs($val);
        }
      } @else if $step == desktop {
        @include query-between(fetch($q, desktop), fetch($q, lgdesktop)) {
          @include _set-fs($val);
        }
      } @else if $step == tablet {
        @include query-between(fetch($q, tablet), fetch($q, desktop)) {
          @include _set-fs($val);
        }
      } @else if $step == mobile {
        @include query-below(fetch($q, tablet)) {
          @include _set-fs($val);
        }
      } @else {
        @include _set-fs($values);
      }
    }
  }
}

@mixin typo-sizes() {
  @each $name, $values in $typo-sizes {
    @if $name == root {
      @at-root {
        html, body {
          -webkit-font-smoothing: antialiased;
          -moz-osx-font-smoothing: grayscale;
          font-family: $font-primary, $font-system;
          font-weight: $fh-regular;
          text-rendering: geometricPrecision;
          @include typo-steps($values);
        }
      }
    } @else {
      @at-root #{$name} {
        @include typo-steps($values);
      }

      .typo-#{$name} {
        @if (str-index($name, 'a-')) {
          font-family: $font-primary, $font-system;
        } @else {
          font-family: $font-secondary, $font-system;
          letter-spacing: 2px;
        }
        @include typo-steps($values);
      }
    }
  }
}

@mixin typo-weights() {
  @each $key, $value in $weights {
    .typo-#{$key} {
      font-weight: #{$value};
    }
  }
}

%typo-h {
  padding-top: 30px;
  padding-bottom: 30px;
  font-weight: $fh-normal;
  letter-spacing: -0.01em;
}

;

@mixin typo-base() {
  @include typo-sizes();
}

@mixin typo-lists() {
  @at-root {
    ul, ol, dl {
      margin-top: 1em;
      padding-left: 20px;
    }

    .list {
      margin: 30px 0;
      padding-left: 60px;
      list-style: none;

      li {
        margin: 0 0 1em;

        &:last-child {
          margin-bottom: 0;
        }
      }
    }

    .list--ordered {
      counter-reset: li;

      li {
        position: relative;

        &:before {
          content: counter(li, decimal-leading-zero) '.';
          counter-increment: li;
          position: absolute;
          left: -40px;
          top: 0;
        }
      }
    }

    .list--unordered {
      li {
        position: relative;

        &:before {
          content: '';
          counter-increment: li;
          position: absolute;
          left: -40px;
          top: 6px;
          width: 8px;
          height: 8px;
          border-radius: 50%;
          background-color: rgba(black, 0.5);
        }
      }
    }
  }
}

@mixin typo() {
  @include typo-base();
  @include typo-lists();
  @include typo-weights();
  //@include typo-font-families();
}

// Apply typo rules
#{$rootNode} {
  @include typo();
}
